(function(win){
    __functionIndexMap = {};

    function createCallbackFunction(funcName, callbackFunc) {
        if (callbackFunc && callbackFunc.name != null && callbackFunc.name.length > 0) {
            return callbackFunc.name;
        }
        if (typeof win[funcName + 0] != 'function') {
            win[funcName + 0] = callbackFunc;
            __functionIndexMap[funcName] = 0;
            return funcName + 0;
        } else {
            var maxIndex = __functionIndexMap[funcName];
            var newIndex = ++maxIndex;
            win[funcName + newIndex] = callbackFunc;
            return funcName + newIndex;
        }
    }

    function wrapCallback(functionName, callback){
        var callbackFuncName;
        if (callback) {
            if (typeof callback == 'function') {
                 callbackFuncName = createCallbackFunction(functionName + "_" + "callback", callback);
            } else {
                 callbackFuncName = callback;
           }
        }
        console.log("call func name is:", callbackFuncName);
        return callbackFuncName;
    }

    var kf = {};

    if(win.kf){
        console.log("window kf existed");
        kf = win.kf;
    }else{
        console.log("now window kf , create one");
        win.kf = kf;
    }

    kf.getHeadParams = function () {
        return win.kx.getHeadParams();
    };

    kf.checkLoginState = function () {
        return win.kx.checkLoginState();
    };


    kf.openUrlByClient = function (url) {
         win.kx.openUrlByClient(url);
    };

    kf.shareByClient = function (shareInfo) {
        win.kx.shareByClient(shareInfo);
    };


    kf.getResourceInfo = function (callback) {
        win.kx.getResourceInfo(wrapCallback("getResourceInfo", callback));
    };

    kf.setScreen = function (dict){
          win.kx.setScreen(dict);
    };


    kf.buy = function(resourceInfo, callback){
        win.kx.buy(resourceInfo, wrapCallback("buy",callback));
    };

    kf.playMusicAlbum = function (album){
        win.kx.playMusicAlbum(album);
    };

    kf.login = function(callback){
        win.kx.login(wrapCallback("login", callback));
    };

    kf.playVideoAlbum = function (album){
        win.kx.playVideoAlbum(album);
    };

    kf.showMessage = function (message){
        win.kx.showMessage(message);
    };

    kf.confirm = function (message){
            win.kx.confirm(message);
        };

    kf.refresh = function (){
        win.kx.refresh();
    };

    kf.getUserInfo = function(callback){
        win.kx.getUserInfo(wrapCallback("getUserInfo", callback));
    };

    kf.isInLocal = function(orids, callback){
        win.kx.isInLocal(orids, wrapCallback("isInLocal",callback));
    };

    kf.download = function(resourceInfo){
       win.kx.download(resourceInfo);
    };

    kf.registerDownloadCallback = function(callback){
       win.kx.registerDownloadCallback(wrapCallback("registerDownloadCallback", callback));
    };

})(window);